`default_nettype none
module i2s(dout, lrout, data, bck, lrck);
input wire data, bck, lrck;
output reg signed [31:0] dout = 32'sb0;
output reg lrout = 1'b0;
reg [4:0] bitnr = 5'b11111;
reg signed [31:0] dpar = 32'sb0;
reg lr1 = 1'b0;
reg lr2 = 1'b0;
always @ (posedge bck)
begin
	lr1 <= lrck;
	lr2 <= lr1;
	if (lr1 ^ lr2)
	begin
		dout <= dpar;
		lrout <= lr2;
		dpar[30:0] <= 31'b0;
		dpar[31] <= data;
		bitnr <= 5'b11111;
	end
	else
	begin
		if (bitnr != 5'b00000)
		begin
			dpar[bitnr-1] <= data;
			bitnr <= bitnr - 5'b00001;
		end
	end
end
endmodule
`default_nettype wire
